#include <map>
#include <unordered_map>
#include <iterator>
#include <iomanip> // wegen setw
#include <utility> // wg. pair
#include <iterator> // e.g. ostream_iterator
#include <string>
#include "dosFarben.h"


#include<iostream>
using namespace std;





void FillElems(map<string, double >& ar_cont) {
   typedef map<string, double >::value_type elem;
   ar_cont.insert(elem("Meier", 8400.14));
   ar_cont.insert(elem("Schulz", 4600.26));
   ar_cont.insert(elem("Kohl", 8800.67));
   ar_cont.insert(elem("Eser", 147.73));
   // es wird nicht ueberschrieben, wenn schon vorhanden
   ar_cont.insert(elem("Meier", 2200.11));
   ar_cont.insert(elem("Kohl", 7880.67));
}

double CalcDurch(const map<string, double >& ar_cont){
   double durch = 0.0;
   for (const auto& iter : ar_cont) {
      durch += iter.second;
   }
   return ar_cont.empty() ? 0.0 : durch / ar_cont.size();

}
void PrintCont(
   const map<string, double >& ar_cont,
   double ad_durch
) {
   for (const auto& iter : ar_cont)   {
      cout << "Key: " << setw(7) << iter.first << ' '
         << "Value: " << setw(8) << iter.second
         << setw(6)
         << (iter.second > ad_durch ? " reich" : "arm")
         << endl;
   }
}

void berechneDurchgehaltMitMap() {
   map<string, double >  cont;
   FillElems(cont);
   PrintCont(cont, CalcDurch(cont));
}



#ifdef SIE_SIND_DRAN
void FillElems(unordered_map<string, double >& ar_cont)
{
}

...

#endif


/*********************************** Template   ***************/
#ifdef FIRST_PART_OF_AUFGABE05_DONE
template <typename Cont>
void FillElemsTemp(Cont& ar_cont)
{
}

template <typename Cont>
double CalcDurchTemp(const Cont& ar_cont)
{
}

template <typename Cont>
void PrintContTemp
(
   const Cont& ar_cont,
   double ad_durch
)
{
}
#endif

void aufgabe5()
{
   printScreenColorOnceVal(cout, RED_SCREEN_COLOR,
      "\nAufgabe 5  noch nicht fertig:\n");
   printScreenColorOnceVal(cout, RED_SCREEN_COLOR,
      "Aufgabe 5  kommt spaeter dran:\n");
   berechneDurchgehaltMitMap();
}
